/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"

//############################################################################
//Diese Routine erzeugt eine Checksumme
int checksum (unsigned char * pointer,unsigned int result16,unsigned long result32)
//############################################################################
{
	unsigned int result16_1 = 0x0000;
	unsigned char DataH;
	unsigned char DataL;
	
	while(result16 > 1){	//Jetzt werden alle Pakete in einer While Schleife addiert
		DataH=*pointer++;		//schreibt Inhalt Pointer nach DATAH danach inc Pointer
		DataL=*pointer++;		//schreibt Inhalt Pointer nach DATAL danach inc Pointer
		result16_1 = ((DataH << 8)+DataL);	//erzeugt Int aus Data L und Data H
		result32 = result32 + result16_1;		//Addiert Paket zu Vorherigen
		result16 -=2;			//verringert Lnge von TCP Headerschleife um 2
	}

	if(result16 > 0){		//Ist der Wert result16 ungerade ist DataL = 0
		DataH=*pointer;		//schreibt Inhalt Pointer nach DATAH danach inc Pointer
		result16_1 = (DataH << 8);		//erzeugt Int aus Data L ist 0 (ist nicht in der Berechnung) und Data H
		result32 = result32 + result16_1;		//Addiert Paket zu Vorherigen
	}
	
	//Komplementbildung (addiert Long INT_H Byte mit Long INT L Byte)
	result32 = ((result32 & 0x0000FFFF)+ ((result32 & 0xFFFF0000) >> 16));
	result32 = ((result32 & 0x0000FFFF)+ ((result32 & 0xFFFF0000) >> 16));	
	result16 =~(result32 & 0x0000FFFF);
	
return (result16);
}

